;===============================================================================
; * IR-vastuvtja. Kuuleb tavalist RC-5 pulti, kanalinupu vajutamisel viib     *
; vastava vljundi krgeks. Vljund on krge kuni jrgmist nuppu vajutatakse   *
; valede klahvide vajutamisel lhevad kik vljundid madalaks                  *
; * Felch (felc@edu.ttu.ee)      26.6.2005                                     *
;===============================================================================
	INCLUDE "P16F628.INC" 
	__CONFIG _WDT_OFF&_INTRC_OSC_NOCLKOUT&_PWRTE_ON&_CP_ALL&_MCLRE_OFF&_BODEN_ON&_LVP_OFF
				errorlevel -302					; Compaileri vingumised ra
				errorlevel -305
				errorlevel -306 
; ***** Constaanzid *****    
#define	kask_0		0x01						; llita vljundit 0
#define	kask_1		0x02						; llita vljundit 1
#define	kask_2		0x03						; llita vljundit 2
#define	kask_3		0x04						; llita vljundit 3
#define	kask_4		0x05						; llita vljundit 4
#define	kask_5		0x06						; llita vljundit 5
#define	kask_6		0x07						; llita vljundit 6
#define	kask_7		0x08						; llita vljundit 7

; ***** Variaablid *****    
RAMbase         equ     20            
	cblock  	RAMbase                 
				flags                 
				temp                 
				Table_Temp 
				W_Temp                 
				S_Temp                 
				T_Temp                 
				Old_T_Temp                 
				RC5_Bit_Count                 
				RC5_Command                 
				RC5_Address
				Kasuloendi
				Viimane_Kask
				Viimane_Aadr
				temp_2  
		endc 

;*********************** Raudvrk **********************************************
;#define	Out_0			PORTA,0					; vljund 0
;#define	Out_1			PORTA,1					; vljund 1
;#define	Out_2			PORTA,2					; vljund 2
;#define	Out_3			PORTA,3					; vljund 3
;#define	Out_4			PORTA,4					; vljund 4
;#define	Out_5			PORTA,5					; vljund 5
;#define	Out_6			PORTA,6					; vljund 6
;#define	Out_7			PORTA,7					; vljund 7
;#define IR_in			PORTB,0					; IR-vastuvtja sisend


; ***** igat masti lipud *****  
#define Last_RC5_Bit    flags,1                 ; Viimane vastuvetud RC5 bit 
#define RC5_2nd_Bit     flags,2                 ; Liida 2 RC5 bitti
#define RC5_2nd_Value   flags,3                 ; 2.vastuvetud RC5 bitt
#define RC5_Bit         flags,4                 ; 1.vastuvetud RC5 bitt
#define SEL_BANK_0      bcf     STATUS,RP0      ; vali Bank 0 
#define SEL_BANK_1      bsf     STATUS,RP0      ; vali Bank 1 
#define CARRY           STATUS,C 
#define ZERO            STATUS,Z 

;seadmete aadressid
#define aadress			00h						; Sellise aadresiga pakettidele reageerime. IR-pultidel on see aadress tavaline
#define TESTTIMES		d'5'					; niimitu korda laseme teadet saata ja vrrelda enne kra tstmist

; ***** RESET *****          
				org     0000h 
Reset_Vector         
				goto    Main_Start       		
;===============================================================================
; ********************** katskestused ******************************************
;===============================================================================
Interrupt_Vector         
				org     0004h 
Push    		movwf   W_Temp           		; Save W         
				swapf   STATUS,W         
				movwf   S_Temp           		; Save STATUS         
				SEL_BANK_0 
Disable_Int     bcf     INTCON,GIE       		; Disable all Interrupts         
				btfsc   INTCON,GIE       		; Are Interrupts disabled ?         
				goto    Disable_Int      		; NO, try again          
				btfsc   INTCON,INTF      		; Skip PORTB0/Interrupt?         
				goto    RB0_Int          		; NO, goto RB0          
				btfsc   INTCON,T0IF      		; Skip Timer Overflow Interrupt ?         
				goto    Timer_Int        		; NO, goto Timer Interrupt  
Pop     		swapf   S_Temp,W         
				movwf   STATUS           		; Return STATUS         
				swapf   W_Temp,F         
				swapf   W_Temp,W         		; Return W         
;				bcf     INTCON,T0IF     		; Clear Overflow       
;				bsf     INTCON,T0IE        		; Timer Interrupts'id lubatud
				retfie                   		; Return setting GIE  
;===============================================================================
; ********************** RB0/INT RC5 Interrupt *********************************
;===============================================================================
RB0_Int     	bcf     INTCON,T0IE      		; Disable further Timer0 Interrupts         
				bcf     INTCON,T0IF      		; Clear Overflow Flag          
				movf    TMR0,W           		; Get Timer Value                 
				movwf   T_Temp           		; And rescue          
				movlw   b'00000011'      		; W takes 1:16         
				clrf    TMR0         
				SEL_BANK_1         
				iorwf   OPTION_REG,F     		; 1:16         
				SEL_BANK_0          
				bcf     RC5_2nd_Bit  
; ***** First Bit ??? ******          
				movf    RC5_Bit_Count,F         
				btfsc   ZERO         
				goto    RC5_Add_1  
; ***** Decide which window contains T_Temp [ <> 8C <> CF <> ]           
				movlw   h'8C'         
				subwf   T_Temp,W         		; Carry will be cleared if T_Temp < 8C ie 2T         
				btfss   CARRY                   ; Skip if >= 8C         
				goto    Timer_is_2T  	 
; must be >= 8C          
				movlw   h'CF'            		; Idem with CF         
				subwf   T_Temp,W         
				btfss   CARRY         
				goto    Timer_is_3T  
Timer_is_4T         
				btfss   Last_RC5_Bit     		; Was last bit "1" ?         
				goto    RC5_Rx_Error     		; No, was "0", error!         
				goto    RC5_Add_01       		; Last bit was "1", add "01"  
Timer_is_2T         
				btfss   Last_RC5_Bit     		; Was last bit "1" ?         
				goto    RC5_Add_0        		; No, was "0", add "0"         
				goto    RC5_Add_1        		; No, was "1", add "1"  
Timer_is_3T         
				btfss   Last_RC5_Bit     		; Was last bit "1" ?         
				goto    RC5_Add_1        		; No, was "0", add "1"         
				goto    RC5_Add_00       		; Last bit was "1", add "00"  
; ***** If Two Bits must be added, the first one is always a 0  
RC5_Add_01         
				bsf     RC5_2nd_Value         
				goto    RC5_Add_0X  
RC5_Add_00         
				bcf     RC5_2nd_Value  
RC5_Add_0X         
				bsf     RC5_2nd_Bit  
RC5_Add_0         
				bcf     RC5_Bit         
				goto    RC5_Add_Bit  
RC5_Add_1         	
				bsf     RC5_Bit  
RC5_Add_Bit         
     
				btfss   RC5_Bit          			; Save bit for future         
				goto    RC5_was_0
				bsf     Last_RC5_Bit 
				goto    RC5_Test_End 
RC5_was_0                                       
         		bcf     Last_RC5_Bit                   
RC5_Test_End                                    
				incf    RC5_Bit_Count,F  			; Increment Bit Count
			    movlw   d'2'             			; Test if RC5 bit extended (bit 2)         
				subwf   RC5_Bit_Count,W
			    btfsc   ZERO             			; If extended bit then         
				goto    RC5_Command_Rotate			; add extended bit to Command
; testi nd bitti 3, see on new key pressed - vi ei tasuks?
			    movlw   d'9'             			; Test Bit Count for >= 9         
				subwf   RC5_Bit_Count,W  			; Carry will be set if >= 9         
				btfss   CARRY            			; Skip if >= 9  ehk kui >=9, on tegemist ksubitiga
;				;goto    RC5_Add_Bit_End  
				goto	  RC5_check_adr
RC5_Command_Rotate         
				rlf     RC5_Command      			; RC5 Command Section         
				bcf     RC5_Command,0         
				btfsc   RC5_Bit          			; Skip next if 0         
				bsf     RC5_Command,0  
RC5_Add_Bit_End         
				btfss   RC5_2nd_Bit      			; Add two bits ?         
				goto    RC5_Int_End      			; No, End Interrupt         
				bcf     RC5_2nd_Bit      			; Two bits, now one bit!         
				btfsc   RC5_2nd_Value    			; Second bit is 0 ?         
				goto    RC5_Add_1        			; No, add a 1         
				goto    RC5_Add_0        			; Yes, add a 0  
RC5_Rx_Error  
RC5_Int_End             
				bsf     INTCON,T0IE      			; Enable Timer0 Interrupts         
				bcf     INTCON,INTF      			; Clear Interrupt PortB Flag         
				goto    Pop              			; Quit via POP  
RC5_check_adr
				movlw   d'4'		 	 			; kas vastu vetud biti jrk.nr. >=4?
				subwf   RC5_Bit_Count,W  			; Carry set kui >= 4         
				btfss   CARRY            			; Skip if >= 4  ehk kui >=4, on tegemist aadressi bittidega       
				goto	RC5_Add_Bit_End  			; olidki startbitid
RC5_Address_Rotate
				rlf     RC5_Address      			; RC5 Aadressi Sektsioon         
				bcf     RC5_Address,0         
				btfsc   RC5_Bit          			; Skip next if 0         
				bsf     RC5_Address,0  
				goto	RC5_Add_Bit_End  		
;===============================================================================
; ********************** Taimeri Interrupt *************************************
;===============================================================================
Timer_Int:      bcf     INTCON,T0IE     			; Disable further Timer0 Interrupts         
				bcf     INTCON,T0IF     			; Clear Overflow       
   
				movlw   d'13'           			; Test Bit Count = 13         
				subwf   RC5_Bit_Count,W 			; Zero will be set if Count = 13         
				btfss   ZERO            			; Skip if = 13, will need to add a 0         
				goto    No_Zero_Needed         
				incf    RC5_Bit_Count,F 			; Increment Bit Count         
				rlf     RC5_Command     			; RC5 Command Section         
				bcf     RC5_Command,0  

No_Zero_Needed         
				movlw   b'01000000'     			; Do some cosmetics:         
				xorwf   RC5_Command,F   			; Put extended above normal commands  
; RC5 Gimmicks         
     
				movlw   d'14'           			; Test Bit Count = 14 ;       
				subwf   RC5_Bit_Count,W 			; Zero will be set if Count = 14 ;       
				btfss   ZERO            			; Skip if = 14, do normal ;       
				goto    RC5_was_Err     			; Error display 
         
				
				movlw	d'0'						; mitu korda ksk saadud ?
				subwf   Kasuloendi,W
				btfsc	ZERO						; esimene kord ?
				goto    esimene_kask				; mnjah

				movf	Viimane_Aadr,W				; kas aadress sama mis eelmises ksus ?
				subwf   RC5_Address,W   
				btfss   ZERO            			; null, kui ok
				goto	lopetame					; erinevad -> jama majas, ra siit
				movlw   TESTTIMES					; 5* sama ksk vastu vetud ?
				subwf   Kasuloendi,W
				btfsc	ZERO						; ongi nii ?
				goto    dekodeeri					; mnjah, tundub kll. Vaatame mis nad tahavad...
				goto	veel_kaske					; vara veel...

esimene_kask
				movf    RC5_Address,W   			; Geti saadud aadress         
				movwf   Viimane_Aadr				; jta meelde
				movf    RC5_Command,W   			; Geti saadud ksk         
				movwf   Viimane_Kask				; jta meelde
veel_kaske
				incf	Kasuloendi					; kasvata ksuloendit
				goto	RC5_Timer_Reset 			; ootab uut ksku


lopetame
				clrf    Kasuloendi      			; ksk edukalt vastu vetud, puhasta registrid saastast   
				clrf    Viimane_Kask         
				clrf    Viimane_Aadr         
				goto	RC5_Timer_Reset 			; ootab uut ksku


dekodeeri
; kas meie aadress?
				movlw	aadress						; Selline on meie ige aadress
				subwf   RC5_Address,W   			; Zero kui saadeti meie aadress
				btfsc   ZERO
				goto	Dekodeeri_kask
				goto	RC5_Timer_Reset
Dekodeeri_kask
				movlw   kask_0						; llitada vljundit 0 ?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	Dek_1						; ei, vaata edasi
				movlw	0x01						; jah, juhi vljundit
				movwf	PORTA
				goto    RC5_Timer_Reset 
Dek_1:			movlw   kask_1						; llitada vljundit 1 ?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	Dek_2						; ei, vaata edasi
				movlw	0x02						; jah, juhi vljundit
				movwf	PORTA
				goto    RC5_Timer_Reset 
Dek_2:			movlw   kask_2						; llitada vljundit 2 ?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	Dek_3						; ei, vaata edasi
				movlw	0x04						; jah, juhi vljundit
				movwf	PORTA
				goto    RC5_Timer_Reset 
Dek_3:			movlw   kask_3						; llitada vljundit 3 ?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	Dek_4						; ei, vaata edasi
				movlw	0x08						; jah, juhi vljundit
				movwf	PORTA
				goto    RC5_Timer_Reset 
Dek_4:			movlw   kask_4						; llitada vljundit 4 ?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	Dek_5						; ei, vaata edasi
				movlw	0x10						; jah, juhi vljundit
				movwf	PORTA
				goto    RC5_Timer_Reset 
Dek_5:			movlw   kask_5						; llitada vljundit 5 ?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	Dek_6						; ei, vaata edasi
				movlw	0x20						; jah, juhi vljundit
				movwf	PORTA
				goto    RC5_Timer_Reset 
Dek_6:			movlw   kask_6						; llitada vljundit 6 ?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	Dek_7						; ei, vaata edasi
				movlw	0x40						; jah, juhi vljundit
				movwf	PORTA
				goto    RC5_Timer_Reset 
Dek_7:			movlw   kask_7						; llitada vljundit 7 ?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	RC5_was_Err					; ei, rokkohv
				movlw	0x80						; jah, juhi vljundit
				movwf	PORTA
				goto    RC5_Timer_Reset 
RC5_was_Err   	movlw	0x00						; vale kood, nullime vljundid
				movwf	PORTA      
;; Reset RC5 variables  
RC5_Timer_Reset         	
				bsf     Last_RC5_Bit         
				clrf    RC5_Bit_Count         
				clrf    RC5_Command    				; valmistume uueks ksuks          
				clrf    RC5_Address          
				goto    Pop            				; Quit via POP 
;===============================================================================
; ********************** philuup **********************************************
;===============================================================================
Main_Start:		call    Init_RC5         		; RC5-vastuvtt kima tmmata   
dummi:			goto	dummi					; ripub siin silmuses ja teeb mitte midagi...kuni IR-kood tuleb
 
;===============================================================================
; ********************** Alamproged ********************************************
;===============================================================================
; ***** Initialise RC5 *****  
Init_RC5          
				bsf     Last_RC5_Bit         
				clrf    RC5_Bit_Count         
				clrf    RC5_Command  
				clrf    Kasuloendi         
				clrf    Viimane_Kask         
				clrf    Viimane_Aadr         
; ***** Set up Timer for RC5         
				SEL_BANK_0         
				bcf     INTCON,T0IE				; Taimeri Interruptsid keelata         
				clrwdt                    		; nulli WDT         
				SEL_BANK_1         
				movlw   0x00         
				movwf	OPTION_REG				; taimer  
				movlw	0x00
				movwf	TRISA					; port A vljundiks
				movlw	0xFF
				movwf	TRISB					; port B sisendiks    
				SEL_BANK_1         
				bcf     OPTION_REG,INTEDG 		; IR-Interrupt langeval frondil
				SEL_BANK_0          
				bsf     INTCON,INTE       		; luba RB0/INT         
				bsf     INTCON,GIE        		; Luba Interruptsid
				return  
	END  
